package pl.poznan.put.erepodevel;

import com.openkm.ws.client.FormElementComplex;
import com.openkm.ws.client.FormElementComplexArray;
import com.openkm.ws.client.Option;
import com.openkm.ws.client.PropertyGroup;
import com.openkm.ws.client.PropertyGroupArray;

public class Test {

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		Test test = new Test();
		
		try {
			OKMAuthMethods am = new OKMAuthMethods();

			try {
				am.login("okmAdmin", "admin");
				test.propertyGroupCheck(am);			
			} catch (Exception e) {
				e.printStackTrace();
			} finally {
				am.logout();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private void propertyGroupCheck(OKMAuthMethods am) {
		OKMPropertyGroupMethods pgm = new OKMPropertyGroupMethods();
		PropertyGroup tempProperty = null;
		String token = am.getSessionId();
		try {
			PropertyGroupArray propertyList = pgm.getAllGroups(am
					.getSessionId());
			tempProperty = propertyList.getItem().get(0);
			if (!tempProperty.equals(null)) {
				PropertyGroupArray pga = null;
				pga = pgm.getGroups(token, "/okm:root/devel.txt");
				for (PropertyGroup p : pga.getItem()) {
					System.out.println("Label: " + p.getLabel() + " Name: "
							+ p.getName());
				}
				
				boolean b = pgm.hasGroup(token, "/okm:root/test.txt", "okg:technology");
				System.out.println("hasGroup: "+b);
				FormElementComplexArray propList = pgm.getProperties(token, "/okm:root/test.txt", "okg:technology");
				for (FormElementComplex f : propList.getItem()) {
					System.out.println("---------Technology----------");
					System.out.println("Label: " + f.getLabel() + "\nName: " + f.getName() 
							+ "\nHeight: " + f.getHeight() + "\nWidth: " + f.getWidth() 
							+ " \nValue: " + f.getValue()+"\nOptions:" + f.getOptions() 
							+ "\nType:" + f.getType());					
					if (!f.getOptions().isEmpty()) {
						System.out.println("----Options----");
						for (Option o : f.getOptions()) {
							System.out.println("Label: "+o.getLabel()+"\nSelected: "+o.isSelected());
						}
					}
				}
				propList = pgm.getProperties(token, "/okm:root/test.txt", "okg:consulting");
				for (FormElementComplex f : propList.getItem()) {
					System.out.println("---------Consulting----------");
					System.out.println("Label: " + f.getLabel() + "\nName: " + f.getName() 
							+ "\nHeight: " + f.getHeight() + "\nWidth: " + f.getWidth() 
							+ " \nValue: " + f.getValue()+"\nOptions:" + f.getOptions() 
							+ "\nType:" + f.getType());
					if (!f.getOptions().isEmpty()) {
						System.out.println("----Options----");
						for (Option o : f.getOptions()) {
							System.out.println("Label: "+o.getLabel()+"\nSelected: "+o.isSelected());
						}
					}
				}	
				
				FormElementComplexArray propListToSet = pgm.getProperties(token, "/okm:root/test.txt", "okg:technology");
				pgm.setProperties(token, "/okm:root/devel.txt", "okg:technology", propListToSet);
				
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

}
